
#include"rfid.h"
#include <LiquidCrystal_I2C.h>
#include <Wire.h>
LiquidCrystal_I2C lcd(0x27,16,2);
RFID rfid; 
#define relayPin 8  

uchar serNum[5]; 
int buzzerPin = 13;
void setup()
{

  pinMode(buzzerPin,OUTPUT);
  digitalWrite(buzzerPin,HIGH);
  lcd.init(); 
  lcd.backlight(); 
  Serial.begin(9600);
  analogWrite(9, 0);
  analogWrite(10, 0);
  rfid.begin(7, 5, 4, 3, 6, 2);
  delay(100); 
  rfid.init(); 
  pinMode(relayPin, OUTPUT);  
  digitalWrite(relayPin,HIGH); 
  
  lcd.setCursor(0,0);
  lcd.print("    Welcome!    "); 
  lcd.setCursor(0,1);
  lcd.print("Chech The Card");
  delay(2000);

}
void loop()
{
  uchar status;
  uchar str[MAX_LEN];
   
  status = rfid.request(PICC_REQIDL, str);
  if (status != MI_OK)
  {
    return;
  }
  
  rfid.showCardType(str);
  
  status = rfid.anticoll(str);

  if (status == MI_OK)
  {
    lcd.setCursor(0,0);
    lcd.print(" ID: ");
    memcpy(serNum, str, 5);
    rfid.showCardID(serNum);

    uchar* id = serNum;
    if( id[0]==0x23 && id[1]==0x0F && id[2]==0xC4 && id[3]==0xBC ) 
    {
      digitalWrite(relayPin,LOW);
      lcd.setCursor(0,1);
      lcd.print("   Home Key   ");
      analogWrite(9, 0);
      analogWrite(10, 150);
      delay(2000);
      lcd.clear();
      digitalWrite(relayPin,HIGH);
      analogWrite(9, 0);
      analogWrite(10, 0);
    } 
    
    else if(id[0]==0xE0 && id[1]==0x45 && id[2]==0xC0 && id[3]==0xBB) 
    {
      digitalWrite(relayPin,LOW);
      lcd.setCursor(0,1);
      lcd.print(" Campus Card    ");
      delay(2000);
      lcd.clear();
      digitalWrite(relayPin,HIGH);
    } 
    else if(id[0]==0xF1 && id[1]==0x23 && id[2]==0x2D && id[3]==0xEC)
    {
      digitalWrite(relayPin,LOW);
      lcd.setCursor(0,1);
      lcd.print("   Bus Card    ");
      delay(2000);
      lcd.clear();
      digitalWrite(relayPin,HIGH);
    }
    else
    {
      digitalWrite(buzzerPin,LOW);
      lcd.setCursor(0,1);
      lcd.print(" UNKNOWN CARD!  ");
      delay(2000);
      lcd.clear();
    }
  }
  lcd.setCursor(0,0);
  lcd.print("    Welcome!    ");
  lcd.setCursor(0,1);
  lcd.print("Chech The Card");
  digitalWrite(buzzerPin,HIGH);
  delay(2000);
  rfid.halt();
}
